// DotsList.cpp: implementation of the CDotsList class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Mnogougol.h"
#include "DotsList.h"
#include "math.h"

#define RAND_MAX 20

IMPLEMENT_SERIAL(CDotsList, CObject, 0)

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDotsList::CDotsList()
{
	pHeadDots=NULL;
	pEndDots=NULL;
	Num_elem=0;
	NearestIndx=0;
}

CDotsList::~CDotsList()
{

}

void CDotsList::Append(CDot *in_dot)
{
	if(pHeadDots==NULL)
	{
		pHeadDots=new CDot;
		pHeadDots->x=in_dot->x;
		pHeadDots->y=in_dot->y;
		pHeadDots->pNext=NULL;
		pEndDots=pHeadDots;
		Num_elem++;
		return;
	}

	CDot *temp=pEndDots;
	temp->pNext = new CDot;
	temp->pNext->x=in_dot->x;
	temp->pNext->y=in_dot->y;
	temp->pNext->pNext=pHeadDots;
	pEndDots=temp->pNext;

	Num_elem++;
}

void CDotsList::Insert(int index, CDot *in_dot)
{
	if(!Num_elem) return;
	if(index==1)
	{
		Append(in_dot);
		return;
	}

	if(index<=Num_elem&&index>1)
	{
		CDot *tmp, *temp2=pHeadDots, *temp3=pHeadDots;
	
		tmp = new CDot;
		tmp=in_dot;
	
		for(int i=1;i<index-1;i++)
			temp2=temp2->pNext;

		for(i=1;i<index;i++)
			temp3=temp3->pNext;

		temp2->pNext=tmp;
		tmp->pNext=temp3;

		Num_elem++;
		return;
	}
	if(index>Num_elem) return;
}

void CDotsList::Delete(int index)
{
	if(!Num_elem) return;
	if(index>Num_elem) return;
	if(index==1&&Num_elem==1)
	{
		pHeadDots=NULL;
		Num_elem--;
		return;
	}
	if(index==1)
	{
		pHeadDots=pHeadDots->pNext;
		pEndDots->pNext=pHeadDots;
		Num_elem--;
		return;
	}
	if(index<Num_elem&&index>1)
	{
		CDot *tmp=pHeadDots, *temp2=pHeadDots;
		for(int i=1;i<index-1;i++)
			tmp=tmp->pNext;
	
		for(i=1;i<index+1;i++)
			temp2=temp2->pNext;

		tmp->pNext=temp2;
		Num_elem--;
		return;
	}
	if(index==Num_elem)
	{
		CDot *tmp=pHeadDots;
		for(int i=1;i<index-1;i++)
			tmp=tmp->pNext;
		tmp->pNext=pHeadDots;
		pEndDots=tmp;
		pEndDots->pNext=pHeadDots;
			
		Num_elem--;
		return;
	}
}

void CDotsList::Render(CDC *in_DC, COLORREF in_color, int in_rad)
{
	if(Num_elem)
	{
		CBrush brush;
		brush.CreateSolidBrush(in_color);
		in_DC->SelectObject(&brush);

		CDot *temp=pHeadDots;

		in_DC->MoveTo(pHeadDots->x, pHeadDots->y);

		for(int i=0;i<Num_elem;i++)
		{
			in_DC->LineTo(temp->x, temp->y);
			temp=temp->pNext;
		}
		in_DC->MoveTo(pEndDots->x, pEndDots->y);
		in_DC->LineTo(pHeadDots->x, pHeadDots->y);
		

		temp=pHeadDots;	
		for(i=0;i<Num_elem;i++)
		{
			in_DC->Ellipse(temp->x-in_rad/2, temp->y-in_rad/2, temp->x+in_rad/2, temp->y+in_rad/2);
			temp=temp->pNext;
		}		
	}
}

int CDotsList::CheckPoint(CPoint in_point, int in_rad)
{
	if(!Num_elem) return -1;
	CDot *tmp=pHeadDots;
	for(int i=1;i<=Num_elem;i++)
	{
		if(in_point.x<=(tmp->x+in_rad/2)&&in_point.x>=(tmp->x-in_rad/2)&&in_point.y<=(tmp->y+in_rad/2)&&in_point.y>=(tmp->y-in_rad/2))	return i;
		tmp=tmp->pNext;
	}
	return -1;
}

CDot* CDotsList::GetDot(int index)
{
	CDot *tmp=pHeadDots;
	if(index<=Num_elem)	
	{
		for(int i=1;i<index;i++)
			tmp=tmp->pNext;
	}
	else
	{
		for(int i=1;i<index-Num_elem;i++)
			tmp=tmp->pNext;
	}

	return tmp;
}

void CDotsList::Serialize(CArchive &ar)
{
	CObject::Serialize(ar);
	double x,y;
	if(ar.IsStoring())
	{
		ar<<Num_elem;
		for(int i=1;i<=Num_elem;i++)
		{
			x=GetDot(i)->x;
			y=GetDot(i)->y;
			ar<<x;
			ar<<y;
		}
	}
	else
	{
		CDot *temp=new CDot;		
		ar>>Num_elem;
		for(int i=1;i<=Num_elem;i++)
		{
			ar>>x;
			ar>>y;
			Append(x,y);
			Num_elem--;
		}
	}
}

BOOL CDotsList::InFigure(CPoint *point)
{
	if(Num_elem<3)return FALSE;
	CDot *temp1=pHeadDots, *temp2=pHeadDots->pNext, *temp3=pHeadDots->pNext->pNext;
	BOOL IS_IN=FALSE;
	for(int i=0;i<Num_elem+1;i++)
	{
		if(!(((((point->x-temp1->x)/(temp2->x-temp1->x)-(point->y-temp1->y)/(temp2->y-temp1->y))>=0)
			&&(((temp3->x-temp1->x)/(temp2->x-temp1->x)-(temp3->y-temp1->y)/(temp2->y-temp1->y))>=0))
			||((((point->x-temp1->x)/(temp2->x-temp1->x)-(point->y-temp1->y)/(temp2->y-temp1->y))<0)
			&&(((temp3->x-temp1->x)/(temp2->x-temp1->x)-(temp3->y-temp1->y)/(temp2->y-temp1->y))<0))))
		{
			return FALSE;			
		}
			
		temp1=temp1->pNext;
		temp2=temp2->pNext;
		temp3=temp3->pNext;
	}
	return TRUE;
}

void CDotsList::Move(double in_x, double in_y)
{
	CDot *temp=pHeadDots;
	for(int i=0;i<Num_elem;i++)
	{
		temp->x+=in_x;
		temp->y+=in_y;
		temp=temp->pNext;
	}
}

BOOL CDotsList::CheckFigure()
{
	if(Num_elem<3) return FALSE;
	CDot *temp1=pHeadDots, *temp2=pHeadDots->pNext, *temp3=pHeadDots->pNext->pNext;
	BOOL Negative=FALSE, First=TRUE;
	for(int i=0;i<Num_elem;i++)
	{
		for(int j=0;j<Num_elem-2;j++)
		{
			if(((temp3->x-temp1->x)/(temp2->x-temp1->x)-(temp3->y-temp1->y)/(temp2->y-temp1->y))>0)
			{
				if(First==TRUE)
				{
					Negative=FALSE;
					First=FALSE;
				}
				else
				{
					if(Negative==TRUE) return FALSE;
					Negative=FALSE;
				}
			}
			if(((temp3->x-temp1->x)/(temp2->x-temp1->x)-(temp3->y-temp1->y)/(temp2->y-temp1->y))<0)
			{
				if(First==TRUE)
				{
					Negative=TRUE;
					First=FALSE;
				}
				else
				{
					if(Negative==FALSE) return FALSE;
					Negative=TRUE;
				}
			}
			temp3=temp3->pNext;
		}
		First=TRUE;
		temp1=temp1->pNext;
		temp2=temp2->pNext;
		temp3=temp2->pNext;
	}
	return TRUE;
}

void CDotsList::ProcessNewDot(CPoint *in_point)
{
	if(Num_elem<3)
	{
		Append(in_point);
		return;
	}
	if(InFigure(in_point))	return;
	else
	{
		int indx1=0, indx2=0, num=1;
		BOOL flag=FALSE;
		for(int i=1;i<=Num_elem;i++)
		{
			for(int j=1;j<=Num_elem;j++)
			{
				if(((CheckSign(in_point->x, in_point->y, GetDot(i)->x, GetDot(i)->y, GetDot(j)->x, GetDot(j)->y)>0)
					&&(CheckSign(in_point->x, in_point->y, GetDot(i)->x, GetDot(i)->y, GetDot(j+1)->x, GetDot(j+1)->y)<0))
					||((CheckSign(in_point->x, in_point->y, GetDot(i)->x, GetDot(i)->y, GetDot(j)->x, GetDot(j)->y)<0)
					&&(CheckSign(in_point->x, in_point->y, GetDot(i)->x, GetDot(i)->y, GetDot(j+1)->x, GetDot(j+1)->y)>0)))
				{
					num++;
				}
			}
			if(num==1)
			{
				if((!indx1)&&(!indx2))
				{
					indx1=i;
					flag=FALSE;
				}
				if((indx1)&&(!indx2)&&(flag==TRUE))
				{
					indx2=i;
				}
			}
			flag=TRUE;
			num=1;
		}
		if(((CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, in_point->x, in_point->y)
			==CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, GetDot(1)->x, GetDot(1)->y))))
		{
			DeleteBtwnIndx(indx1, indx2, FALSE);
			Append(in_point);
			return;
		}
		if(((CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, in_point->x, in_point->y)
			==CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, GetDot(Num_elem)->x, GetDot(Num_elem)->y))))
		{
			DeleteBtwnIndx(indx1, indx2, FALSE);
			Append(in_point);
			return;
		}
		if((indx1==1)&&(indx2==Num_elem)
			&&(CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, in_point->x, in_point->y)
			!=CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, GetDot(indx1+1)->x, GetDot(indx1+1)->y)))
		{
			DeleteBtwnIndx(indx1, indx2, FALSE);
			Append(in_point);
			return;
		}
		/*if((indx2!=Num_elem)
			&&((CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, in_point->x, in_point->y)
			==CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, GetDot(indx2+1)->x, GetDot(indx2+1)->y))
			||((CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, in_point->x, in_point->y)>0)
			&&(!CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, GetDot(indx2+1)->x, GetDot(indx2+1)->y)))
			||((CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, in_point->x, in_point->y)<0)
			&&(!CheckSign(GetDot(indx1)->x, GetDot(indx1)->y, GetDot(indx2)->x, GetDot(indx2)->y, GetDot(indx2+1)->x, GetDot(indx2+1)->y)))))
		{
			//DeleteBtwnIndx(indx1, indx2, FALSE);
			//Insert(indx1, in_point);
			return;
		}*/
		else
		{
			DeleteBtwnIndx(indx1, indx2, TRUE);
			Insert(indx1+1, in_point);
			return;
		}
	}
}

int CDotsList::GetNearestDotIndx(CPoint *in_point)
{
	if(Num_elem<3) return -1;
	CDot *temp=pHeadDots;
	double minLength, tempLength;
	int Index=1;
	for(int i=1;i<=Num_elem;i++)
	{
		tempLength=(temp->x-in_point->x)*(temp->x-in_point->x)+(temp->y-in_point->y)*(temp->y-in_point->y);
		tempLength=sqrt(tempLength);
		if(i==1) 
		{
			minLength=tempLength;
			Index=1;
		}
		if(tempLength<minLength)
		{
			minLength=tempLength;
			Index=i;
		}
		temp=temp->pNext;
	}
	return Index;
}

double CDotsList::GetLength(double x1, double y1, double x2, double y2)
{
	double Length;
	Length=(x1-x2)*(x1-x2)+(y1-y2)*(y1-y2);
	Length=sqrt(Length);
	return Length;
}

void CDotsList::Insert(int index, CPoint *in_point)
{
	if(!Num_elem) return;
	if(index==1)
	{
		Append(in_point);
		return;
	}

	if(index<=Num_elem&&index>1)
	{
		CDot *tmp, *temp2=pHeadDots, *temp3=pHeadDots;
	
		tmp = new CDot;
		tmp->x=in_point->x;
		tmp->y=in_point->y;
	
		for(int i=1;i<index-1;i++)
			temp2=temp2->pNext;

		for(i=1;i<index;i++)
			temp3=temp3->pNext;

		temp2->pNext=tmp;
		tmp->pNext=temp3;

		Num_elem++;
		return;
	}
	if(index>Num_elem) return;	
}

void CDotsList::Append(CPoint *in_point)
{
	if(pHeadDots==NULL)
	{
		pHeadDots=new CDot;
		pHeadDots->x=in_point->x;
		pHeadDots->y=in_point->y;
		pHeadDots->pNext=NULL;
		pEndDots=pHeadDots;
		Num_elem++;
		return;
	}

	CDot *temp=pEndDots;

	temp->pNext = new CDot;
	temp->pNext->x=in_point->x;
	temp->pNext->y=in_point->y;
	temp->pNext->pNext=pHeadDots;
	pEndDots=temp->pNext;

	Num_elem++;
}

void CDotsList::DeleteAll()
{
	while(pHeadDots!=NULL)
		Delete(1);
}

void CDotsList::Append(double x, double y)
{
	if(pHeadDots==NULL)
	{
		pHeadDots=new CDot;
		pHeadDots->x=x;
		pHeadDots->y=y;
		pHeadDots->pNext=NULL;
		pEndDots=pHeadDots;
		Num_elem++;
		return;
	}

	CDot *temp=pEndDots;

	temp->pNext = new CDot;
	temp->pNext->x=x;
	temp->pNext->y=y;
	temp->pNext->pNext=pHeadDots;
	pEndDots=temp->pNext;

	Num_elem++;
}

int CDotsList::CheckSign(double x1, double y1, double x2, double y2, double in_x, double in_y)
{
	if((((in_x-x1)/(x2-x1))-((in_y-y1)/(y2-y1)))>0)return 1;
	if((((in_x-x1)/(x2-x1))-((in_y-y1)/(y2-y1)))<0)return -1;
	else return 0;
}

BOOL CDotsList::CheckCrossing(double x1, double y1, double x2, double y2, double in_x, double in_y)
{
	if((((in_x-x1)/(x2-x1))-((in_y-y1)/(y2-y1)))==0)return TRUE;
	else return FALSE;
}

void CDotsList::DeleteBtwnIndx(int index1, int index2, BOOL Del_flag)
{
	if(index1==index2)
	{
		Delete(index1);
		return;
	}
	if(Del_flag)
	{
		int n;
		if(index1>index2)n=index1-index2;
		if(index2>index1)n=index2-index1;
		for(int i=1;i<n;i++)
		{
			if(index1>index2) Delete(index2+1);
			if(index2>index1) Delete(index1+1);
		}
		return;
	}
	else
	{
		if(index1<index2)
		{
			for(int i=1;i<index1;i++)
			{
				Delete(1);
				index2--;
			}
			int n=Num_elem;
			for(i=index2;i<n;i++)
				Delete(index2+1);
			return;
		}
		if(index1>index2)
		{
			for(int i=1;i<index2;i++)
				Delete(1);
			for(i=index1;i<=Num_elem;i++)
				Delete(index1+1);
			return;
		}		
	}
}

void CDotsList::ProcessDndDot(int index)
{
	if(Num_elem<3) return;
	if(!CheckFigure())
	{
		CPoint temp;
		temp.x=GetDot(index)->x;
		temp.y=GetDot(index)->y;
		Delete(index);
		ProcessNewDot(&temp);
	}
}

void CDotsList::Dynamics(int dnd_dot)
{
	for(int i=1;i<=Num_elem;i++)
	{
		if(i==dnd_dot) continue;
		else
		{
			DynamicsOfDot(GetDot(i));
			/*if(rand()>17500)
			{
				GetDot(i)->x+=2;
				GetDot(i)->y-=2;
			}
			else 
			{
				GetDot(i)->x-=2;
				GetDot(i)->y+=2;
			}*/
			ProcessDndDot(i/*, dnd_dot*/);
		}
	}
}
