// DotsList.h: interface for the CDotsList class.
//
//////////////////////////////////////////////////////////////////////
#include "Dynamics.h"

#if !defined(AFX_DOTSLIST_H__A6A31D43_5CC4_4DC9_845E_D75912A0259D__INCLUDED_)
#define AFX_DOTSLIST_H__A6A31D43_5CC4_4DC9_845E_D75912A0259D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*struct CDot
{
	double x,y;
	CDot *pNext;
};*/

class CDotsList:public CObject  
{
	DECLARE_SERIAL(CDotsList)
public:
	CDot *pHeadDots;
	CDot *pEndDots;
	int Num_elem;
	int NearestIndx;
public:
	void Dynamics(int dnd_dot);
	void ProcessDndDot(int index);
	void DeleteBtwnIndx(int index1, int index2, BOOL Del_flag);
	int CheckSign(double x1, double y1, double x2, double y2, double in_x, double in_y);
	BOOL CheckCrossing(double x1, double y1, double x2, double y2, double in_x, double in_y);
	void Append(double x, double y);
	void DeleteAll();
	void Append(CPoint *in_point);
	void Insert(int index, CPoint *in_point);
	double GetLength(double x1, double y1, double x2, double y2);
	int GetNearestDotIndx(CPoint *in_point);
	void ProcessNewDot(CPoint *in_point);
	BOOL CheckFigure();
	void Move(double in_x, double in_y);
	BOOL InFigure(CPoint *point);
	void Serialize(CArchive& ar);
	int CheckPoint(CPoint in_point, int in_rad);
	void Render(CDC *in_DC, COLORREF in_color, int in_rad);
	CDotsList();
	virtual ~CDotsList();
	void Delete(int index);
	void Insert(int index, CDot *in_dot);
	void Append(CDot *in_dot);
	CDot* GetDot(int index);
};

#endif // !defined(AFX_DOTSLIST_H__A6A31D43_5CC4_4DC9_845E_D75912A0259D__INCLUDED_)
