// MnogougolView.cpp : implementation of the CMnogougolView class
//

#include "stdafx.h"
#include "Mnogougol.h"

#include "MnogougolDoc.h"
#include "MnogougolView.h"
#include "ColorDlg.h"
#include "RadiusDlg.h"
#include "HelpDlg.h"

#define WM_APPLY WM_USER+1

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMnogougolView

IMPLEMENT_DYNCREATE(CMnogougolView, CView)

BEGIN_MESSAGE_MAP(CMnogougolView, CView)
	//{{AFX_MSG_MAP(CMnogougolView)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_OPTIONS_COLOR, OnOptionsColor)
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_OPTIONS_RADIUS, OnOptionsRadius)
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	ON_COMMAND(ID_DYNAMICS_START, OnDynamicsStart)
	ON_COMMAND(ID_DYNAMICS_STOP, OnDynamicsStop)
	ON_MESSAGE(WM_APPLY, OnApply)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CRadiusDlg *RadDlg;

/////////////////////////////////////////////////////////////////////////////
// CMnogougolView construction/destruction

CMnogougolView::CMnogougolView()
{
	dndfig_flag=FALSE;
	dnddot_flag=FALSE;
	RadDlg=NULL;
	//RadDlg->m_rad=10;
	// TODO: add construction code here

}

CMnogougolView::~CMnogougolView()
{
}

BOOL CMnogougolView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMnogougolView drawing

void CMnogougolView::OnDraw(CDC* pDC)
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	CDC tempDC;
	CRect rect;
	CBitmap tempBitMap; 
	CBrush br;
	br.CreateSolidBrush(RGB(255,255,255));

	tempDC.CreateCompatibleDC(pDC);		
	
	GetClientRect(&rect);	

	tempBitMap.CreateCompatibleBitmap(pDC, rect.right, rect.bottom);
	tempDC.SelectObject(&tempBitMap);

	tempDC.FillRect(&rect, &br);
	if(!pDoc->Dots.CheckFigure())tempDC.TextOut(20,20,"FALSE");
	else tempDC.TextOut(20,20,"TRUE");

	pDoc->Dots.Render(&tempDC, pDoc->color, pDoc->rad);

	pDC->BitBlt(0, 0, rect.right, rect.bottom, &tempDC, 0, 0, SRCCOPY);
	tempBitMap.DeleteObject();
	tempDC.DeleteDC();

}

/////////////////////////////////////////////////////////////////////////////
// CMnogougolView diagnostics

#ifdef _DEBUG
void CMnogougolView::AssertValid() const
{
	CView::AssertValid();
}

void CMnogougolView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMnogougolDoc* CMnogougolView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMnogougolDoc)));
	return (CMnogougolDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMnogougolView message handlers

void CMnogougolView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	dnd_num=pDoc->Dots.CheckPoint(point, pDoc->rad);
	if(dnd_num>=0)
		dnddot_flag=TRUE;

	dndfig_flag=pDoc->Dots.InFigure(&point);
	if(dnddot_flag&&dndfig_flag) dndfig_flag=FALSE;
	LastPoint=point;

	pDoc->SetModifiedFlag();
	CView::OnLButtonDown(nFlags, point);
}

void CMnogougolView::OnOptionsColor() 
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CColorDlg dlg;
	dlg.m_cc.Flags |= CC_FULLOPEN | CC_RGBINIT;
	dlg.m_cc.rgbResult = RGB(255, 0, 0);
	if(dlg.DoModal()==IDOK)
	{
		pDoc->color=dlg.GetColor();
		pDoc->SetModifiedFlag();
		Invalidate(0);
	}
}

void CMnogougolView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	int n=pDoc->Dots.CheckPoint(point, pDoc->rad);
	if(n==-1) /*pDoc->Dots.Append(&point);//*/pDoc->Dots.ProcessNewDot(&point);
	else pDoc->Dots.Delete(n);

	pDoc->SetModifiedFlag();
	Invalidate(0);

		
	CView::OnRButtonDown(nFlags, point);
}

void CMnogougolView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(dnddot_flag)
	{
		dnddot_flag=FALSE;
		pDoc->Dots.GetDot(dnd_num)->x=point.x;
		pDoc->Dots.GetDot(dnd_num)->y=point.y;
		pDoc->Dots.ProcessDndDot(dnd_num);
		Invalidate(0);
	}
	if(dndfig_flag)
	{
		double dx=point.x-LastPoint.x, dy=point.y-LastPoint.y;
		dndfig_flag=FALSE;
		pDoc->Dots.Move(dx, dy);
		Invalidate(0);
	}
	pDoc->SetModifiedFlag();
			
	CView::OnLButtonUp(nFlags, point);
}

void CMnogougolView::OnOptionsRadius() 
{
	if(RadDlg==NULL)
	{
		RadDlg = new CRadiusDlg(this);
		RadDlg->m_rad=GetDocument()->rad;
		RadDlg->Create(IDD_DIALOGRADIUS, this);
		RadDlg->m_sliderrad.SetPos(GetDocument()->rad);
		RadDlg->m_sliderrad.SetRange(0, 100);
		RadDlg->m_sliderrad.SetTicFreq(10);
	}
}

LRESULT CMnogougolView::OnApply(UINT wParam, LONG lParam)
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->rad=RadDlg->m_rad;
	if(wParam==IDOK)
		RadDlg->DestroyWindow();
	RedrawWindow();
	Invalidate(0);
	return TRUE;
}

void CMnogougolView::OnDone()
{
	RadDlg=NULL;
}

void CMnogougolView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(dnddot_flag)
	{
		pDoc->Dots.GetDot(dnd_num)->x=point.x;
		pDoc->Dots.GetDot(dnd_num)->y=point.y;
		Invalidate(0);
	}
	if(dndfig_flag)
	{
		double dx=point.x-LastPoint.x, dy=point.y-LastPoint.y;
		pDoc->Dots.Move(dx, dy);
		Invalidate(0);
		LastPoint=point;
	}
	CView::OnMouseMove(nFlags, point);
}

void CMnogougolView::OnHelpContents() 
{
	CHelpDlg dlg;
	dlg.DoModal();
}

void CMnogougolView::OnDynamicsStart() 
{
	SetTimer(1, 55, NULL);			
}

void CMnogougolView::OnDynamicsStop() 
{
	KillTimer(1);	
}

void CMnogougolView::OnTimer(UINT nIDEvent) 
{
	CMnogougolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	if(dnddot_flag)	pDoc->Dots.Dynamics(dnd_num);
	else pDoc->Dots.Dynamics(0);

	Invalidate(0);
	
	CView::OnTimer(nIDEvent);
}
